# include <unistd.h>
# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include <fcntl.h>
# include <sys/mman.h>
# include <sys/types.h>
# include <sys/stat.h>

# include "question8.h"

# define TRANS 8
# define ORDRE 7

typedef struct s_lgraphe *t_lgraphe;
struct s_lgraphe {
  size_t	ordre;
  size_t	orient;
  size_t	size;
  int		trans[2]; /* c'est pas la taille qui compte */
};

int trans[TRANS*2] =
  {
    6,7,
    5,6,
    5,3,
    4,7,
    3,4,
    2,3,
    1,5,
    1,2
  };

int make_graphe(t_lgraphe *lg){
  t_lgraphe g;
  g = malloc(sizeof(struct s_lgraphe) + sizeof(int)*TRANS*2 - 2);
  *lg = g;
  g->ordre = ORDRE;
  g->orient = 1;
  g->size = TRANS;
  memcpy(g->trans,trans,TRANS*2*sizeof(int));
  return (sizeof(struct s_lgraphe) + sizeof(int)*TRANS*2 - 2);
}

int main(int argc, char *argv[])
{
  t_lgraphe g;
  int s,fd;
  if (argc<2)
    return 2;
  s = make_graphe(&g);
  fd = open(argv[1],O_WRONLY|O_CREAT|O_TRUNC,0644);
  write(fd,(void *)g,s);
  close(fd);
  return 0;
}
