type expr =
    Bool of bool
  | Not of expr
  | Or of expr * expr
  | And of expr * expr
  | Impl of expr * expr
  | Eq of expr * expr
  | Var of string
val eval : (string, bool) Hashtbl.t -> expr -> bool
