(*
 * Test question 4
 *)

open Question4

(* Partie test: ne pas modifier *)
let _ =
  let seed = ref (-1) in
  let file = ref "" in
  let usage = "Prog TP: question 4\nquestion4 graine file" in
  let anonfun s =
    try
      seed := int_of_string s
    with
	Failure "int_of_string" ->
	  if (!seed <> -1) then file := s
	  else
	    (Arg.usage (Arg.align []) usage ;
	     exit 1)
      | _ ->
	  Arg.usage (Arg.align []) usage ;
	  exit 1
  in
    Arg.parse (Arg.align []) anonfun usage ;
    if (!seed = -1) then
      begin
	Arg.usage (Arg.align []) usage ;
	exit 1
      end;
    Random.init !seed;
    let e = ParseExpr.parseExpr !file in
    let varlist = ParseExpr.getVars e in
    let env =
      let env = Hashtbl.create 43 in
	begin
	  ParseExpr.StringSet.iter (fun x -> Hashtbl.add env x (Random.bool ())) varlist;
	  env
	end
    in
      Format.printf "@[<b>e = @,";
      ParseExpr.pretty_print e;
      Format.printf "@]@.";
      Format.printf "@[<b>env = @,@[<b>[";
      Hashtbl.iter (fun k v -> Format.printf "%s => %b;@, " k v) env;
      Format.printf "]@]@]@.";
      Format.printf "e -> %b@." (eval env e);
      exit 0
