/*
 * Test question 6
 */

# include <unistd.h>
# include <stdio.h>
# include "cheaters.h"
# include <errno.h>

# include "question6.h"

size_t get_size(char *s)
{
  int res;
  res = (size_t)strtol(s, (char **)NULL, 10);
  if (errno==EINVAL)
    return (-1);
  return res;
}

char rand_char(){
  char c;
  c = (char)(rand()%26 + 'a');
  return c;
}

void print_list(t_list l)
{
  if (l)
    {
      write(STDOUT_FILENO,&(l->content),1);
      print_list(l->next);
    }
  else
    write(STDOUT_FILENO,"\n",1);
}

int main(int argc, char **argv)
{
  size_t size, seed;
  t_list l=NULL;
  if (argc<3)
    {
      write(STDERR_FILENO,"Prog TP: question 6\nquestion6 graine taille\n",44);
      exit(2);
    }
  seed = get_size(argv[1]);
  size = get_size(argv[2]);

  srand(seed);

  while (size--)
    {
      l = add_fun(l,rand_char());
    }

  print_list(l);

  exit(0);
}
