%token <string> VAR
%token <bool> BOOL
%token AND OR NOT IMP EQ
%token LPAREN RPAREN
%token EOF
%left IMP EQ        /* lowest precedence */
%left OR
%left AND
%nonassoc NOT        /* highest precedence */
%start main             /* the entry point */
%type <Question4.expr> main
%%
main:
expr EOF                { $1 };
  
expr:
  VAR                      { Question4.Var $1 }
  | BOOL                   { Question4.Bool $1 }
  | LPAREN expr RPAREN     { $2 }
  | expr AND expr          { Question4.And($1,$3) }
  | expr OR  expr          { Question4.Or($1,$3) }
  | expr IMP expr          { Question4.Impl($1,$3) }
  | expr EQ  expr          { Question4.Eq($1,$3) }
  | NOT expr               { Question4.Not $2 }
;
