/*
 * Test question 5
 */

# include <unistd.h>
# include <stdio.h>
# include "cheaters.h"
# include <errno.h>

# include "question5.h"

size_t get_size(char *s)
{
  int res;
  res = (size_t)strtol(s, (char **)NULL, 10);
  if (errno==EINVAL)
    return (-1);
  return res;
}

int main(int argc, char **argv)
{
  size_t size, j=0;
  char c, *s=NULL;
  if (argc<4)
    {
      write(STDERR_FILENO,"Prog TP: question 5\nquestion5 size char string\n",47);
      exit(2);
    }
  
  size = get_size(argv[1]);
  c = argv[2][0];
  s = calloc(size+1,1);
  while (argv[3][j])
    {
      if (j<size)
	s[j] = argv[3][j];
      write(STDOUT_FILENO,argv[3]+(j++),1);
    }
  write(STDOUT_FILENO,"\n",1);
  mystrnfill(s,c,size);
  write(STDOUT_FILENO,s,size-1);
  write(STDOUT_FILENO,"\n",1);

  exit(0);
}
